package com.fr.plugin.sqy.kj.calendar.form;


import com.fanruan.api.design.DesignKit;
import com.fr.design.designer.creator.CRPropertyDescriptor;
import com.fr.design.designer.creator.XDirectWriteEditor;
import com.fr.design.gui.itextfield.UITextField;
import com.fr.design.i18n.Toolkit;
import com.fr.design.layout.FRGUIPaneFactory;
import com.fr.design.mainframe.widget.editors.DateFormatEditor;
import com.fr.design.mainframe.widget.editors.DateRangeEditor;
import com.fr.design.mainframe.widget.editors.WidgetValueEditor;
import com.fr.design.mainframe.widget.renderer.DateCellRenderer;
import com.fr.form.ui.DateEditor;
import com.fr.form.ui.WidgetValue;
import com.fr.form.ui.concept.data.ValueInitializer;
import com.fr.general.DateUtils;
import com.fr.plugin.sqy.kj.calendar.PluginConstants;
import com.fr.plugin.sqy.kj.calendar.widget.FormCalendarWidget;
import com.fr.stable.ArrayUtils;
import com.fr.stable.StringUtils;
import com.fr.stable.core.PropertyChangeAdapter;

import javax.swing.*;
import java.awt.*;
import java.beans.IntrospectionException;
import java.util.Date;

public class FormXDateEditor extends XDirectWriteEditor {
    private UITextField textField;
    private LimpidButton btn;

    public FormXDateEditor(FormCalendarWidget widget, Dimension size) {
        super(widget, size);
    }

    @Override
    public String getIconPath() {
        return "com/fr/plugin/sqy/kj/calendar/log/calendar.png";
    }


    @Override
    public CRPropertyDescriptor[] supportedDescriptor() throws IntrospectionException {
        return (CRPropertyDescriptor[])
                ((CRPropertyDescriptor[])ArrayUtils
                        .addAll(super.supportedDescriptor()
                                , new CRPropertyDescriptor[]{
                                        (new CRPropertyDescriptor("widgetValue", this.data.getClass()))
                                                .setI18NName(Toolkit.i18nText("Fine-Design_Form_Widget_Value"))
                                                .setEditorClass(WidgetValueEditor.class)
                                                .putKeyValue("category", "Fine-Design_Basic_Advanced")
                                                .setPropertyChangeListener(new PropertyChangeAdapter() {
                                            public void propertyChange() {
                                                FormXDateEditor.this.initFieldText();
                                            }
                                        })
                                        ,(new CRPropertyDescriptor("formatText", this.data.getClass()))
                                                .setI18NName(Toolkit.i18nText("Fine-Design_Report_Engine_Format"))
                                                .setEditorClass(this.formatClass())
                                                .setRendererClass(DateCellRenderer.class)
                                                .putKeyValue("category", "Fine-Design_Basic_Advanced")
                                        , (new CRPropertyDescriptor("startDate", this.data.getClass()))
                                        .setI18NName(PluginConstants.START_DATE_NAME)
                                        .putKeyValue("category", "Fine-Design_Basic_Advanced")
                                        .setEditorClass(DateRangeEditor.class)
                                        , (new CRPropertyDescriptor("endDate", this.data.getClass()))
                                        .setI18NName(Toolkit.i18nText("Fine-Design_Report_FS_End_Date"))
                                        .putKeyValue("category", "Fine-Design_Basic_Advanced")
                                        .setEditorClass(DateRangeEditor.class)
                                        , (new CRPropertyDescriptor("waterMark", this.data.getClass()))
                                        .setI18NName(Toolkit.i18nText("Fine-Design_Form_WaterMark"))
                                        .putKeyValue("category", "Fine-Design_Basic_Advanced")
                                        , (new CRPropertyDescriptor("returnDate", this.data.getClass()))
                                        .setI18NName(Toolkit.i18nText("Fine-Design_Form_Return_Date"))
                                        .putKeyValue("category", "Fine-Design_Basic_Advanced")
                        }));
    }

    protected Class formatClass() {
        return DateFormatEditor.class;
    }

    private void initFieldText() {
        DateEditor var1 = (DateEditor)this.data;
        if (var1.getWidgetValue() != null) {
            ValueInitializer var2 = var1.getWidgetValue();
            String var3 = var2.toString();
            Object var4 = var2.getValue();
            String var5 = var1.getFormatText();
            if (var4 instanceof Date) {
                var3 = DateUtils.getDate2Str(var5, (Date)var4);
            }

            if (StringUtils.isEmpty(var3)) {
                var3 = DateUtils.getDate2Str(var5, new Date());
                var1.setWidgetValue(new WidgetValue(new Date()));
            }

            this.textField.setText(var3);
        }

    }


    @Override
    protected JComponent initEditor() {
        if (this.editor == null) {
            this.editor = FRGUIPaneFactory.createBorderLayout_S_Pane();
            this.editor.add(this.textField = new UITextField(5), "Center");
            this.btn = new LimpidButton("", this.getIconPath(), this.toData().isVisible() ? 1.0F : 0.4F);
            this.btn.setPreferredSize(new Dimension(21, 21));
            this.editor.add(this.btn, "East");
            this.textField.setOpaque(false);
            this.editor.setBackground(Color.WHITE);
        }
        return this.editor;
    }


}
