package com.fr.plugin.sqy.kj.calendar.pane;

import com.fr.base.FRContext;
import com.fr.data.core.FormatField;
import com.fr.design.border.UIRoundedBorder;
import com.fr.design.constants.UIConstants;
import com.fr.design.gui.ibutton.UIButtonGroup;
import com.fr.design.gui.icombobox.UIComboBox;
import com.fr.design.gui.ilable.UILabel;
import com.fr.design.i18n.Toolkit;
import com.fr.design.layout.FRGUIPaneFactory;
import com.fr.design.layout.TableLayoutHelper;
import com.fr.design.widget.component.DateValuePane;
import com.fr.design.widget.component.UIComboBoxNoArrow;
import com.fr.design.widget.ui.DirectWriteEditorDefinePane;
import com.fr.plugin.sqy.kj.calendar.widget.CellCalendarWidget;
import com.fr.stable.ArrayUtils;

import javax.swing.*;
import javax.swing.border.TitledBorder;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.SimpleDateFormat;
import java.util.Date;

public class CalendarPane extends DirectWriteEditorDefinePane<CellCalendarWidget> {
    private UIButtonGroup returnTypeComboBox;
    private DateValuePane startDv;
    private DateValuePane endDv;
    private UIComboBox currentFormatComboBox;
    private com.fr.design.gui.ilable.UILabel currentSamplelabel;
    private UIButtonGroup fomatHeadGroup;
    private static final int SAMPLE_LABEL_PADDING = 4;

    public CalendarPane() {
    }

    protected String title4PopupWindow() {
        return "Date";
    }

    protected JPanel setSecondContentPane() {
        this.returnTypeComboBox = new UIButtonGroup(new String[]{Toolkit.i18nText("Fine-Design_Basic_Date"), Toolkit.i18nText("Fine-Design_Basic_String")});
        JPanel var1 = this.createFormatHead();
        this.startDv = new DateValuePane();
        this.endDv = new DateValuePane();
        double var2 = -1.0D;
        double var4 = -2.0D;
        com.fr.design.gui.ilable.UILabel var6 = new com.fr.design.gui.ilable.UILabel(Toolkit.i18nText("Fine-Design_Report_Engine_Format"));
        var6.setVerticalAlignment(1);
        com.fr.design.gui.ilable.UILabel var7 = new com.fr.design.gui.ilable.UILabel(Toolkit.i18nText("Fine-Design_Report_FS_Start_Date"));
        var7.setVerticalAlignment(1);
        com.fr.design.gui.ilable.UILabel var8 = new com.fr.design.gui.ilable.UILabel(Toolkit.i18nText("Fine-Design_Report_FS_End_Date"));
        var8.setVerticalAlignment(1);
        Component[][] var9 = new Component[][]{{var6, var1}, {var7, this.startDv}, {var8, this.endDv}, {this.waterMarkDictPane, null}, {new com.fr.design.gui.ilable.UILabel(Toolkit.i18nText("Fine-Design_Basic_Widget_Date_Selector_Return_Type")), this.returnTypeComboBox}};
        double[] var10 = new double[]{var4, var4, var4, var4, var4, var4, var4};
        double[] var11 = new double[]{var4, var2};
        int[][] var12 = new int[][]{{1, 3}, {1, 1}, {1, 1}, {1, 1}, {1, 1}};
        JPanel var13 = TableLayoutHelper.createGapTableLayoutPane(var9, var10, var11, var12, 13.0D, 10.0D);
        return var13;
    }

    private JPanel createFormatPane(UIComboBox var1, com.fr.design.gui.ilable.UILabel var2) {
        JPanel var3 = FRGUIPaneFactory.createBorderLayout_S_Pane();
        TitledBorder var4 = new TitledBorder(new UIRoundedBorder(UIConstants.LINE_COLOR, 1, 5), Toolkit.i18nText("Fine-Design_Report_Base_StyleFormat_Sample"), 4, 2, this.getFont(), UIConstants.LINE_COLOR);
        var3.setBorder(var4);
        JPanel var5 = new JPanel(new BorderLayout());
        var5.setBorder(BorderFactory.createEmptyBorder(0, 4, 4, 4));
        var5.add(var2, "Center");
        var3.add(var5, "Center");
        JPanel var6 = FRGUIPaneFactory.createBorderLayout_S_Pane();
        var6.add(var3, "North");
        var6.add(var1, "Center");
        return var6;
    }

    private com.fr.design.gui.ilable.UILabel createSamplePane() {
        com.fr.design.gui.ilable.UILabel var1 = new com.fr.design.gui.ilable.UILabel("") {
            public void setText(String var1) {
                super.setText("<html>" + var1 + "</html>");
            }
        };
        var1.setHorizontalAlignment(0);
        var1.setFont(FRContext.getDefaultValues().getFRFont());
        return var1;
    }

    private JPanel createFormatHead() {
        String[] var1 = FormatField.getInstance().getFormatArray(5);
        String[] var2 = FormatField.getInstance().getFormatArray(6);
        final UIComboBoxNoArrow var3 = new UIComboBoxNoArrow(var1);
        final UIComboBoxNoArrow var4 = new UIComboBoxNoArrow(var2);
        var3.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent var1) {
                CalendarPane.this.refreshPreviewLabel();
            }
        });
        var4.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent var1) {
                CalendarPane.this.refreshPreviewLabel();
            }
        });
        final com.fr.design.gui.ilable.UILabel var5 = this.createSamplePane();
        final UILabel var6 = this.createSamplePane();
        JPanel var7 = FRGUIPaneFactory.createBorderLayout_S_Pane();
        final CardLayout var8 = new CardLayout();
        final JPanel var9 = new JPanel(var8);
        JPanel var10 = this.createFormatPane(var3, var5);
        JPanel var11 = this.createFormatPane(var4, var6);
        var9.add(var10, Toolkit.i18nText("Fine-Design_Report_StyleFormat_Date"));
        var9.add(var11, Toolkit.i18nText("Fine-Design_Report_StyleFormat_Time"));
        final String[] var12 = new String[]{Toolkit.i18nText("Fine-Design_Report_StyleFormat_Date"), Toolkit.i18nText("Fine-Design_Report_StyleFormat_Time")};
        this.fomatHeadGroup = new UIButtonGroup(new String[]{Toolkit.i18nText("Fine-Design_Report_StyleFormat_Date"), Toolkit.i18nText("Fine-Design_Report_StyleFormat_Time")});
        this.fomatHeadGroup.addChangeListener(new ChangeListener() {
            public void stateChanged(ChangeEvent var1) {
                int var2 = CalendarPane.this.fomatHeadGroup.getSelectedIndex();
                var8.show(var9, var12[var2]);
                if (var2 == 0) {
                    CalendarPane.this.currentFormatComboBox = var3;
                    CalendarPane.this.currentSamplelabel = var5;
                } else {
                    CalendarPane.this.currentFormatComboBox = var4;
                    CalendarPane.this.currentSamplelabel = var6;
                }

                CalendarPane.this.refreshPreviewLabel();
            }
        });
        var7.add(this.fomatHeadGroup, "North");
        var7.add(var9, "Center");
        return var7;
    }

    private void refreshPreviewLabel() {
        String var1 = (String)this.currentFormatComboBox.getSelectedItem();
        if (var1 != null && var1.length() > 0) {
            try {
                SimpleDateFormat var2 = new SimpleDateFormat(var1);
                String var3 = var2.format(new Date());
                Color var4 = Color.black;
                if (!ArrayUtils.contains(FormatField.getInstance().getDateFormatArray(), var1)) {
                    var3 = var3 + " " + Toolkit.i18nText("Fine-Design_Basic_DateFormat_Custom_Warning");
                    var4 = Color.red;
                }

                this.currentSamplelabel.setText(var3);
                this.currentSamplelabel.setForeground(var4);
            } catch (Exception var5) {
                this.currentSamplelabel.setForeground(Color.red);
                this.currentSamplelabel.setText(var5.getMessage());
            }
        } else {
            this.currentSamplelabel.setText((new Date()).toString());
        }

    }

    private int getDateType(CellCalendarWidget var1) {
        String[] var2 = FormatField.getInstance().getFormatArray(6);
        if (var1 == null) {
            return 0;
        } else {
            String var3 = var1.getFormatText();
            return ArrayUtils.contains(var2, var3) ? 1 : 0;
        }
    }

    protected void populateSubDirectWriteEditorBean(CellCalendarWidget var1) {
        String var2 = var1.getFormatText();
        this.fomatHeadGroup.setSelectedIndex(this.getDateType(var1));
        this.fomatHeadGroup.populateBean();
        this.currentFormatComboBox.setSelectedItem(var2);
        this.returnTypeComboBox.setSelectedIndex(var1.isReturnDate() ? 0 : 1);
        this.startDv.populate(var1.getStartDate());
        this.endDv.populate(var1.getEndDate());
    }

    protected CellCalendarWidget updateSubDirectWriteEditorBean() {
        CellCalendarWidget var1 = new CellCalendarWidget();
        var1.setFormatText(this.getSimpleDateFormat().toPattern());
        var1.setReturnDate(this.returnTypeComboBox.getSelectedIndex() == 0);
        var1.setStartDate(this.startDv.update());
        var1.setEndDate(this.endDv.update());
        return var1;
    }

    private SimpleDateFormat getSimpleDateFormat() {
        String var1 = (String)this.currentFormatComboBox.getSelectedItem();
        SimpleDateFormat var2;
        if (var1 != null && var1.length() > 0) {
            try {
                var2 = new SimpleDateFormat(var1);
                this.currentSamplelabel.setText(var2.format(new Date()));
            } catch (Exception var4) {
                var2 = new SimpleDateFormat("");
            }
        } else {
            var2 = new SimpleDateFormat("");
        }

        return var2;
    }
}
