package com.fr.plugin.sqy.kj.calendar.widget;

import com.fr.form.ui.DateEditor;
import com.fr.general.ComparatorUtils;
import com.fr.json.JSONException;
import com.fr.json.JSONObject;
import com.fr.plugin.sqy.kj.calendar.PluginConstants;
import com.fr.script.Calculator;
import com.fr.stable.core.NodeVisitor;
import com.fr.stable.web.Repository;
import com.fr.stable.xml.XMLPrintWriter;
import com.fr.stable.xml.XMLableReader;

public class CellCalendarWidget extends DateEditor {
    private String config1 = null;

    @Override
    public String getXType() {
        return PluginConstants.KJ_CELL_ID;
    }

    @Override
    public JSONObject createJSONConfig(Repository repository, Calculator calculator, NodeVisitor nodeVisitor) throws JSONException {
        return super.createJSONConfig(repository, calculator, nodeVisitor).put("config1",config1);
    }


    @Override
    public void readXML(XMLableReader xmLableReader) {
        super.readXML(xmLableReader);
        if(xmLableReader.isChildNode()){
            String tagName = xmLableReader.getTagName();
            if(ComparatorUtils.equals(tagName,"config1")){
                this.config1 = xmLableReader.getAttrAsString("config1","");
            }
        }
    }

    @Override
    public void writeXML(XMLPrintWriter xmlPrintWriter) {
        super.writeXML(xmlPrintWriter);
        xmlPrintWriter.startTAG("config1").textNode(config1).end();
    }

    public String getConfig1() {
        return config1;
    }

    public void setConfig1(String config1) {
        this.config1 = config1;
    }
}
